package net.brutex.xservices.ws;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;

import net.brutex.xservices.types.HostConnection;
import net.brutex.xservices.types.ReturnCode;
import net.brutex.xservices.util.BrutexNamespaces;

@WebService(targetNamespace = BrutexNamespaces.WS_XSERVICES)
public interface ExecuteService {

	@WebMethod(operationName = "runCommand")
	public abstract ReturnCode runCommand(
			@WebParam(name = "executable") String cmd,
			@WebParam(name = "argline") String args,
			@WebParam(name = "timeout") long timeout);

	@WebMethod(operationName = "runCommandWithArgs")
	public abstract ReturnCode runCommandWithArgs(
			@WebParam(name = "executable") String cmd,
			@WebParam(name = "arg") String[] args,
			@WebParam(name = "timeout") long timeout);

	@WebMethod(operationName = "runCommandAsync")
	public abstract ReturnCode runCommandAsync(
			@WebParam(name = "executable") String cmd,
			@WebParam(name = "argline") String args);

	@WebMethod(operationName = "runCommandAsyncWithArgs")
	public abstract ReturnCode runCommandAsyncWithArgs(
			@WebParam(name = "executable") String cmd,
			@WebParam(name = "arg") String[] args);

	@WebMethod(operationName = "runCommandWithSSH")
	public abstract ReturnCode runCommandWithSSH(
			@WebParam(name = "host") String host,
			@WebParam(name = "port") int port,
			@WebParam(name = "username") String username,
			@WebParam(name = "password") String password,
			@WebParam(name = "command") String cmd,
			@WebParam(name = "timeout") long timeout);

	@WebMethod(operationName = "runCommandWithSSHKeyAuth")
	public abstract ReturnCode runCommandWithSSHKeyAuth(
			@WebParam(name = "host") String host,
			@WebParam(name = "port") int port,
			@WebParam(name = "username") String username,
			@WebParam(name = "passphrase") String passphrase,
			@WebParam(name = "keyfile") String keyfile,
			@WebParam(name = "command") String cmd,
			@WebParam(name = "timeout") long timeout);

	@WebMethod(operationName = "rExec")
	public abstract ReturnCode rExec(
			@WebParam(name = "host") HostConnection host,
			@WebParam(name = "command") String cmd,
			@WebParam(name = "timeout") long timeout);

	@WebMethod(operationName = "telnet")
	public abstract ReturnCode runTelnet(
			@WebParam(name = "host") HostConnection host,
			@WebParam(name = "prompt") String prompt,
			@WebParam(name = "command") String cmd,
			@WebParam(name = "expect") String expect,
			@WebParam(name = "timeout") long timeout);

}